Classes
Protocols
Constants
Functions
Macros
Types
Variables

### Classes

EOAccessArrayFaultHandler
EOAccessFaultHandler
EOAccessGenericFaultHandler
EOAdaptor
EOAdaptorChannel
EOAdaptorContext
EOAdaptorOperation
EOAttribute
EODatabase
EODatabaseChannel
EODatabaseContext
EODatabaseDataSource
EODatabaseOperation
EOEntity
EOEntityClassDescription
EOJoin
EOLoginPanel
EOModel
EOModelGroup
EORelationship
EOSQLExpression
EOSQLExpressionFactory
EOSQLQualifier
EOStoredProcedure

### Protocols

<EOColumnTypes>
<EOPropertyListEncoding>
<EOQualifierSQLGeneration>
(EOAdaptorChannelDelegation)
(EOAdaptorContextDelegation)
(EOAdaptorDelegate)
(EODatabaseContextDelegation)
(EOModelGroupClassDelegation)
(EOModelGroupDelegation)
(EOSchemaSynchronizationDelegates)

### Constants

### Functions

EODatabaseContext_globalIDForObjectWithImpPtr
EODatabaseContext_snapshotForGlobalIDWithImpPtr
GDL2_EOAccessPrivateInit

### Macros

### Types

EOAdaptorOperator
EODatabaseOperator
EODelegateResponse
EOJoinSemantic
EOUpdateStrategy

### Variables

EOAccessFaultObjectNotAvailableException
EOAdaptorContextBeginTransactionNotification
EOAdaptorContextCommitTransactionNotification
EOAdaptorContextRollbackTransactionNotification
EOAdaptorFailureKey
EOAdaptorKey
EOAdaptorOperationsKey
EOAdaptorOptimisticLockingFailure
EOAdministrativeConnectionDictionaryKey
EOAdministrativeConnectionDictionaryNeededNotification
EOAllowsNullKey
EOBindVariableAttributeKey
EOBindVariableColumnKey
EOBindVariableNameKey
EOBindVariablePlaceHolderKey
EOBindVariableValueKey
EOColumnNameKey
EOConnectionDictionaryKey
EOCreateDatabaseKey
EOCreatePrimaryKeySupportKey
EOCreateTablesKey
EOCustomQueryExpressionHintKey
EODatabaseChannelNeededNotification
EODatabaseContextKey
EODatabaseOperationsKey
EODeleteProcedureOperation
EODistantPastTimeInterval
EODropDatabaseKey
EODropPrimaryKeySupportKey
EODropTablesKey
EOEntityLoadedNotification
EOExternalNameKey
EOExternalTypeKey
EOFailedAdaptorOperationKey
EOFailedDatabaseOperationKey
EOFetchAllProcedureOperation
EOFetchWithPrimaryKeyProcedureOperation
EOForeignKeyConstraintsKey
EOGeneralAdaptorException
EOGeneralDatabaseException
EOInsertProcedureOperation
EOModelAddedNotification
EOModelInvalidatedNotification
EOModelKey
EOMoreThanOneException
EONameKey
EONextPrimaryKeyProcedureOperation
EOPrecisionKey
EOPrimaryKeyConstraintsKey
EORelationshipsKey
EOScaleKey
EOSchemaSynchronizationForeignKeyConstraintsKey
EOSchemaSynchronizationPrimaryKeyConstraintsKey
EOSchemaSynchronizationPrimaryKeySupportKey
EOStoredProcedureNameHintKey
EOWidthKey
GDL2_EOAttributeClass
GDL2_EODatabaseContextClass
GDL2_EODatabaseContext__globalIDForObjectIMP
GDL2_EODatabaseContext_snapshotForGlobalIDIMP
GDL2_EOEntityClass
GDL2_EORelationshipClass
eqSel
struct _EOTransactionScope

Up

# EOAdaptor Class

### Authors

Ovidiu Predescu (`ovidiu@bx.logicnet.ro`)
Mirko Viviani (`mirko.viviani@gmail.com`)
David Wetzel (`dave@turbocat.de`)

Date: Generated at 2026-02-03 22:13:20 +0000

Copyright: (C) 1996-2001,2002,2003,2004,2005 Free Software Foundation, Inc.

### Contents -

1. Software documentation for the EOAdaptor class
2. Software documentation for the EOLoginPanel class
3. Software documentation for the EOAdaptor(EOAdaptorLoginPanel) category
4. Software documentation for the EOAdaptor(EOExternalTypeMapping) category
5. Software documentation for the EOAdaptor(EOSchemaGenerationExtensions) category
6. Software documentation for the NSObject(EOAdaptorDelegate) informal protocol
7. EOAdaptor variables

# Software documentation for the EOAdaptor class

## EOAdaptor : NSObject

> Declared in:
>   EOAccess/EOAdaptor.h

Description forthcoming.

Instance Variables

### Method summary

- -runLoginPanel
- -runLoginPanelAndValidateConnectionDictionary
- +assignExternalInfoForAttribute:
- +assignExternalInfoForEntireModel:
- +assignExternalInfoForEntity:
- +assignExternalTypeForAttribute:
- +externalTypesWithModel:
- +internalTypeForExternalType:model:
- -createDatabaseWithAdministrativeConnectionDictionary:
- -dropDatabaseWithAdministrativeConnectionDictionary:
- -objectStoreChangesFromAttribute:toAttribute:
- +adaptorWithModel:
- +adaptorWithName:
- +availableAdaptorNames
- +setExpressionClassName:adaptorClassName:
- +sharedLoginPanelInstance
- -assertConnectionDictionaryIsValid
- -canServiceModel:
- -connectionDictionary
- -contexts
- -createAdaptorContext
- -databaseEncoding
- -defaultExpressionClass
- -delegate
- -expressionClass
- -expressionFactory
- -fetchedValueForDataValue:attribute:
- -fetchedValueForDateValue:attribute:
- -fetchedValueForNumberValue:attribute:
- -fetchedValueForStringValue:attribute:
- -fetchedValueForValue:attribute:
- -handleDroppedConnection
- -hasOpenChannels
- -initWithName:
- -isDroppedConnectionException:
- -isValidQualifierType:model:
- -model
- -name
- -prototypeAttributes
- -setConnectionDictionary:
- -setDelegate:
- -setModel:

### adaptorWithModel:

+ (id) adaptorWithModel: (EOModel*)model;
Description forthcoming.

### adaptorWithName:

+ (id) adaptorWithName: (NSString*)name;
Description forthcoming.

### availableAdaptorNames

+ (NSArray*) availableAdaptorNames;
Returns an array of EOAdaptor frameworks found in the standard framework locations. If an adaptor is found in multiple locations the name is listed only once. An adaptor framework is recognized the the "EOAdaptor.framework" suffix. The framework name without this suffix is the name returned in the array.

### setExpressionClassName: adaptorClassName:

+ (void) setExpressionClassName: (NSString*)sqlExpressionClassName adaptorClassName: (NSString*)adaptorClassName;
Description forthcoming.

### sharedLoginPanelInstance

+ (EOLoginPanel*) sharedLoginPanelInstance;
Description forthcoming.

### assertConnectionDictionaryIsValid

- (void) assertConnectionDictionaryIsValid;
Description forthcoming.

### canServiceModel:

- (BOOL) canServiceModel: (EOModel*)model;
Description forthcoming.

### connectionDictionary

- (NSDictionary*) connectionDictionary;
Description forthcoming.

### contexts

- (NSArray*) contexts;
Description forthcoming.

### createAdaptorContext

- (EOAdaptorContext*) createAdaptorContext;
Description forthcoming.

### databaseEncoding

- (NSStringEncoding) databaseEncoding;
Description forthcoming.

### defaultExpressionClass

- (Class) defaultExpressionClass;
Description forthcoming.

### delegate

- (id) delegate;
Description forthcoming.

### expressionClass

- (Class) expressionClass;
Description forthcoming.

### expressionFactory

- (EOSQLExpressionFactory*) expressionFactory;
Description forthcoming.

### fetchedValueForDataValue: attribute:

- (NSData*) fetchedValueForDataValue: (NSData*)value attribute: (EOAttribute*)attribute;
Description forthcoming.

### fetchedValueForDateValue: attribute:

- (NSCalendarDate*) fetchedValueForDateValue: (NSCalendarDate*)value attribute: (EOAttribute*)attribute;
Description forthcoming.

### fetchedValueForNumberValue: attribute:

- (NSNumber*) fetchedValueForNumberValue: (NSNumber*)value attribute: (EOAttribute*)attribute;
Description forthcoming.

### fetchedValueForStringValue: attribute:

- (NSString*) fetchedValueForStringValue: (NSString*)value attribute: (EOAttribute*)attribute;
Description forthcoming.

### fetchedValueForValue: attribute:

- (id) fetchedValueForValue: (id)value attribute: (EOAttribute*)attribute;
Description forthcoming.

### handleDroppedConnection

- (void) handleDroppedConnection;
Description forthcoming.

### hasOpenChannels

- (BOOL) hasOpenChannels;
Description forthcoming.

### initWithName:

- (id) initWithName: (NSString*)name;
Description forthcoming.

### isDroppedConnectionException:

- (BOOL) isDroppedConnectionException: (NSException*)exception;
Returns `YES` if the exception is one that the adaptor can attempt to recover from by reconnecting. `NO` otherwise. The default implementation returns `NO`. Subclasses that support database reconnection should override this to allow for automatic database reconnection.

### isValidQualifierType: model:

- (BOOL) isValidQualifierType: (NSString*)attribute model: (EOModel*)model;
Description forthcoming.

### model

- (EOModel*) model;
Description forthcoming.

### name

- (NSString*) name;
Description forthcoming.

### prototypeAttributes

- (NSArray*) prototypeAttributes;
Description forthcoming.

### setConnectionDictionary:

- (void) setConnectionDictionary: (NSDictionary*)dictionary;
Description forthcoming.

### setDelegate:

- (void) setDelegate: (id)delegate;
Description forthcoming.

### setModel:

- (void) setModel: (EOModel*)model;
Description forthcoming.

## Instance Variables for EOAdaptor Class

### _connectionDictionary

@protected NSDictionary* _connectionDictionary;
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _contexts

@protected NSMutableArray* _contexts;
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _delegate

@protected id _delegate;
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _expressionClass

@protected Class _expressionClass;
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _expressionClassName

@protected NSString* _expressionClassName;
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _model

@protected EOModel* _model;
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _name

@protected NSString* _name;
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

# Software documentation for the EOLoginPanel class

## EOLoginPanel : NSObject

> Declared in:
>   EOAccess/EOAdaptor.h

Description forthcoming.

### Method summary

- -runPanelForAdaptor:validate:
- -administrativeConnectionDictionaryForAdaptor:
- -runPanelForAdaptor:validate:allowsCreation:

### administrativeConnectionDictionaryForAdaptor:

- (NSDictionary*) administrativeConnectionDictionaryForAdaptor: (EOAdaptor*)adaptor;
Subclasses should implement this method to return a connection dictionary for an administrative user able to create databases etc. Or `nil` if the the user cancels.

### runPanelForAdaptor: validate: allowsCreation:

- (NSDictionary*) runPanelForAdaptor: (EOAdaptor*)adaptor validate: (BOOL)yn allowsCreation: (BOOL)allowsCreation;
Description forthcoming.

# Software documentation for the EOAdaptor(EOAdaptorLoginPanel) category

## EOAdaptor(EOAdaptorLoginPanel)

> Declared in:
>   EOAccess/EOAdaptor.h

Description forthcoming.

### Method summary

- -runLoginPanel
- -runLoginPanelAndValidateConnectionDictionary

### runLoginPanel

- (NSDictionary*) runLoginPanel;
Invokes [EOLoginPanel -runPanelForAdaptor:validate:allowsCreation:] for the adaptor's +sharedLoginPanelInstance , with `YES` as the validate flag. Returns the dictionary without changing the recievers connection dictionary. Subclass shouldn't need to override this method, yet if the do, they should call this implementation.

### runLoginPanelAndValidateConnectionDictionary

- (BOOL) runLoginPanelAndValidateConnectionDictionary;
Invokes [EOLoginPanel -runPanelForAdaptor:validate:allowsCreation:] for the adaptor's +sharedLoginPanelInstance , with `YES` as the validate flag. If the user supplies valid connection information, the reciever's connection dictionary is updated, and the method return `YES`. Otherwise it returns `NO`. Subclass shouldn't need to override this method, yet if the do, they should call this implementation.

# Software documentation for the EOAdaptor(EOExternalTypeMapping) category

## EOAdaptor(EOExternalTypeMapping)

> Declared in:
>   EOAccess/EOAdaptor.h

Description forthcoming.

### Method summary

- +assignExternalInfoForAttribute:
- +assignExternalInfoForEntireModel:
- +assignExternalInfoForEntity:
- +assignExternalTypeForAttribute:
- +externalTypesWithModel:
- +internalTypeForExternalType:model:

### assignExternalInfoForAttribute:

+ (void) assignExternalInfoForAttribute: (EOAttribute*)attribute;
Invokes [+assignExternalTypeForAttribute:] and unless the attribute is derived it sets the column name if it hasn't been set. An 'attributeName' result in a column named 'ATTRIBUTE_NAME'.
NOTE: This differs from the EOF implementation as EOF unconditionally sets the the external name attributes that are not derived. This can cause trouble on certain RDMS which may not support the extended names used internally in an application. Subclass shouldn't need to override this method, yet if the do, they should call this implementation.

### assignExternalInfoForEntireModel:

+ (void) assignExternalInfoForEntireModel: (EOModel*)model;
Invokes [+assignExternalInfoForEntity:] for each of the model's entities. Subclass shouldn't need to override this method, yet if the do, they should call this implementation.

### assignExternalInfoForEntity:

+ (void) assignExternalInfoForEntity: (EOEntity*)entity;
Invokes [+assignExternalInfoForAttribute:] for each of the model's entities. If the externalName of the entity hasn't been set, this method sets it to a standardized name according to the entities name. An 'entityName' will be converted to 'ENTITY_NAME'.
Subclass shouldn't need to override this method, yet if the do, they should call this implementation.

### assignExternalTypeForAttribute:

+ (void) assignExternalTypeForAttribute: (EOAttribute*)attribute;
Subclasses must override this method without invoking this implementation to set the the external type according to the internal type information. It should take into account width, precesion and scale accordingly.

### externalTypesWithModel:

+ (NSArray*) externalTypesWithModel: (EOModel*)model;
Subclasses must override this method without invoking this implementation to return an array of types available for the RDBMS. A subclass may use information provided by an optional model to determine the exact available types.

### internalTypeForExternalType: model:

+ (NSString*) internalTypeForExternalType: (NSString*)extType model: (EOModel*)model;
Subclasses must override this method without invoking this implementation to return the name of the class used internal to the database for the extType provided. A subclass may use information provided by an optional model to determine the exact type.

# Software documentation for the EOAdaptor(EOSchemaGenerationExtensions) category

## EOAdaptor(EOSchemaGenerationExtensions)

> Declared in:
>   EOAccess/EOAdaptor.h

Description forthcoming.

### Method summary

- -createDatabaseWithAdministrativeConnectionDictionary:
- -dropDatabaseWithAdministrativeConnectionDictionary:

### createDatabaseWithAdministrativeConnectionDictionary:

- (void) createDatabaseWithAdministrativeConnectionDictionary: (NSDictionary*)administrativeConnectionDictionary;
Description forthcoming.

### dropDatabaseWithAdministrativeConnectionDictionary:

- (void) dropDatabaseWithAdministrativeConnectionDictionary: (NSDictionary*)administrativeConnectionDictionary;
Description forthcoming.

# Software documentation for the NSObject(EOAdaptorDelegate) informal protocol

## NSObject(EOAdaptorDelegate)

> Declared in:
>   EOAccess/EOAdaptor.h

Description forthcoming.

### Method summary

- -adaptor:fetchedValueForValue:attribute:
- -reconnectionDictionaryForAdaptor:

### adaptor: fetchedValueForValue: attribute:

- (id) adaptor: (EOAdaptor*)adaptor fetchedValueForValue: (id)value attribute: (EOAttribute*)attribute;
Description forthcoming.

### reconnectionDictionaryForAdaptor:

- (NSDictionary*) reconnectionDictionaryForAdaptor: (EOAdaptor*)adaptor;
Description forthcoming.

# EOAdaptor variables

### EOAdaptorKey

NSString* EOAdaptorKey;
Description forthcoming.

### EOAdministrativeConnectionDictionaryKey

NSString* EOAdministrativeConnectionDictionaryKey;
Description forthcoming.

### EOAdministrativeConnectionDictionaryNeededNotification

NSString* EOAdministrativeConnectionDictionaryNeededNotification;
Description forthcoming.

### EOConnectionDictionaryKey

NSString* EOConnectionDictionaryKey;
Description forthcoming.

### EOGeneralAdaptorException

NSString* EOGeneralAdaptorException;
Description forthcoming.

### EOModelKey

NSString* EOModelKey;
Description forthcoming.

Up